function [WRSS, constr] = Disl_wr(x, origin, xy_gps, nu, d_gps,  Icov, geom_start, xlb, xub)
%
% Compute the weighted residual for Dislocation Model
%	x -- model vector
%	d -- data
%	W -- Weight Matrix
%	nu -- poissson's ratio
%	xy coordinates of stations


	[geom_short, dis_geom_short] = x2geom(x, origin, xlb, xub);
	dis_geom = [dis_geom_short, geom_start(:,8:10)];

	
    	nf = length(x)/7;
	nv = 0;
%%%%******NOTE*******
%%%% This is not going to work with volumetric sources
%%%%******************


	clear G; G = [];

% GPS DATA
if length(d_gps) > 0
for i=1:nf
        if dis_geom(i,8)~=0
          g = relative_disp(nu, [dis_geom(i,1:7),1,0,0], xy_gps);
          g1 = g(1:2,:);
	  G= [G, g1(:)];
        end

        if dis_geom(i,9)~=0
          g = relative_disp(nu, [dis_geom(i,1:7),0,1,0], xy_gps);
          g2 = g(1:2,:);
          G= [G, g2(:)];
        end

        if dis_geom(i,10)~=0
          g = relative_disp(nu, [dis_geom(i,1:7),0,0,1], xy_gps);
          g3 = g(1:2,:);
          G= [G, g3(:)];
        end
end

else
        G = [];
end
	d = [d_gps];

%%Compute Predicted Data
	dhat = G*inv(G'*Icov*G)*G'*Icov*d;


%% compute weighted residual sum of squares
	WRSS = (d - dhat)'*Icov*(d - dhat);


%%%%%%%%%%%

%constr(1) = dis_geom(1,2) - dis_geom(1,3) - 0.1;
%constr(2) = dis_geom(1,3) - dis_geom(1,2) - 0.1;
%constr(3) = dis_geom(2,2) - dis_geom(2,3) - 0.1;
%constr(4) = dis_geom(2,3) - dis_geom(2,2) - 0.1;
constr(1) = dis_geom(1,2).*sin(pi*dis_geom(1,4)/180) - dis_geom(1,3);
%constr(2) = dis_geom(2,2).*sin(pi*dis_geom(2,4)/180) - dis_geom(2,3);
%constr(3) = dis_geom(3,2).*sin(pi*dis_geom(3,4)/180) - dis_geom(3,3);


% constrain sill (fault plane 3) to starting coordinates
% constrain east rift zone (fault plane 4) to starting coordinates
%        x_start = geom2x(geom_start, origin);
%        [geom_foo, dis_geom_start] = x2geom(x_start,origin);
%        constr(2:8) = abs(dis_geom(3,1:7) - dis_geom_start(3,:)); 
%        constr(9:15) = abs(dis_geom(4,1:7) - dis_geom_start(4,:)); 
