%  ForModel.m
%  Script to compute forward dislocation models.
%  Currently implemented for GPS data only
%  Paul Segall, Roland Burgmann 1995

%Poisson's ratio
	nu = 0.25;

%Update fault geometry and station coordinates in local coords
        UpdateGeom_orig

%Set the model origin and convert station coordinates to local coords
  SetOrigin


% CREATE DESIGN MATRIX
% GPS DATA
if length(d_gps) > 0
        xy_gps = llh2localxy(llh_gps, origin);

	if nf > 0
        	G_dis = MakeGgps(dis_geom, xy_gps, nu);
	else
		G_dis = [];
	end
	if nv > 0
		G_vol = MakeGvolgps(vol_geom, xy_gps, nu);
	else
		G_vol = [];
	end


	G = [G_dis, G_vol];
else
	G = [];
end 

% LEVELING DATA

if length(d_lev) > 0
        xy_lev = llh2localxy(llh_lev, origin);

	if nf > 0
		clear G_dis;
        	G_dis = MakeGlev(dis_geom, xy_lev, nu);
	else
		G_dis = [];
	end
	if nv > 0
		clear G_vol;
		G_vol = MakeGvollev(vol_geom, xy_lev, nu);
	else
		G_vol = [];
	end


	G = [G; G_dis, G_vol];

end 
% TILT DATA
%if length(d_tilt) > 0
%        xy_tilt = llh2localxy(llh_tilt, origin);
% 
%        if nf > 0
%                clear G_dis;
%                G_dis = MakeGtilt(dis_geom, xy_tilt, nu);
%        else
%                G_dis = [];
%        end
%        if nv > 0
%                clear G_vol;
%                G_vol = MakeGvoltilt(vol_geom, xy_tilt, nu);
%        else
%                G_vol = [];
%        end
% 
% 
%        G = [G; G_dis, G_vol];
%end


%Plot Geometry in Local Cartesian Coordinates
%        figure
%	if length(d_gps) > 0
%        	plot(xy_gps(:,1), xy_gps(:,2), 'o'), axis('equal'), hold on
%	end
%	if length(d_lev) > 0
%        	plot(xy_lev(:,1), xy_lev(:,2), '+'), axis('equal'), hold on
%	end
%	if length(d_tilt) > 0
%        	plot(xy_tilt(:,1), xy_tilt(:,2), '+'), axis('equal'), hold on
%	end
%
%        for i=1:nf
%         displot(dis_geom(i,:))
%        end
%	for i=1:nv
%	 plot( vol_geom(i,1), vol_geom(i,2), 'r*')
%	end
%        title('Geometry in Local Cartesian Coordinates')
%	hold off
%

% compute weighted residual sum of squares
	slip = [];
	for i = 1:nf
		slip = [slip; dis_geom(i,8:10)'];
	end
	for i = 1:nv
		slip = [slip; vol_geom(i,4)'];
	end

        dhat = G*slip;
	
	r = W*(d - dhat);

        PrintSlip(slip, zeros(size(slip)), nf, nv);
%        PrintResids(r, d_gps, d_lev, d_tilt,  G);
        PrintResids(r, d_gps, G);

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%        disp('   iterate through different Yalova Slip Values ');
%for s = 0:-0.1:-2
%	slip = []; G_free = []; G_dis = [];
%	dis_geom(1,8)=s;
% Estimate all but the first fault slip, however, this does not account for slip on that element
%	G_free = MakeGgps_fix(dis_geom, xy_gps, nu);
%	G_lap=MakeLapF(nsegs,ndeps);
%        G_lap = 1.0 * G_lap;
%        d_lap=zeros(3*nf,1);
%        len_geod=length(d_gps);
%%       TO ADD WEIGHTING TO THE SMOOTHING:
%          G2I=[W*G_free;G_dis;G_lap];
%        Ginv = pinv(G2I);
%        d2I=[W*d(1:len_geod);W_SAR*d_SAR(:);d_lap];
%        slip(4:3*nf) = Ginv(4:3*nf,:)*d2I; Ginv*d2I
%	slip = [dis_geom(1,8:10), slip(4:3*nf)];
%
%        dhat = G*slip'; r = W*(d - dhat);

%%%%%%%%%%%%% Estimate all then fix first fault 
%	for i = 1:nf
%		slip = [slip; dis_geom(i,8:10)'];
%	end
%        Ginv = pinv(W*G);
%        slip = Ginv*W*d;
%	slip(1) =s;
%        cov_slip = Ginv*Ginv';
%        sig_slip = sqrt(diag(cov_slip));
%        dhat = G*slip;
%        r = W*(d - dhat);
% Use Slip values in a priori FaultGeom
%	for i = 1:nf
%		slip = [slip; dis_geom(i,8:10)'];
%	end
%        dhat = G*slip;
%	r = W*(d - dhat);

        n_gps = length(d_gps); r_gps = r(1:n_gps);
        rank_gps = rank(G(1:n_gps,:)); 
        fprintf('Slip = %g\n', slip(1)); slip
        fprintf('WRSS = %g\n', r_gps'*r_gps)
end
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% Clear Plot Files
        !/usr/bin/rm temp.gmtlin
%        !/usr/bin/rm volums.gmtlin
%        !/usr/bin/rm tiltobs.gmtvec
%        !/usr/bin/rm tiltmod.gmtvec
%        !/usr/bin/rm levelobs.gmtvec
%        !/usr/bin/rm levelmod.gmtvec
%        !/usr/bin/rm levelres.gmtvec
        !/usr/bin/rm obs.gmtvec
        !/usr/bin/rm mod.gmtvec
        !/usr/bin/rm res.gmtvec
        !/usr/bin/rm obs_vert.gmtvec
        !/usr/bin/rm mod_vert.gmtvec

% IF horizontal data exists -- plot  vectors

if length(d_gps) > 0
        %plot observed vectors

% This is for a 3D covariance Matrix!
%        [a,b,az] = ErrlpsGMT( cov3d2cov2d(cov_gps)  );
%        nvec = length(d_gps)/3;
%        outmatrix1v = [llh_gps(2,1:nvec)', llh_gps(1,1:nvec)', zeros(1,nvec)', vel(3,1:nvec)', zeros(1,nvec)', zeros(1,nvec)', zeros(1,nvec)'];

% This is for a 2D covariance Matrix!
        [a,b,az] = ErrlpsGMT(cov_gps);
        nvec = length(d_gps)/2;

        outmatrix1 = [llh_gps(2,1:nvec)', llh_gps(1,1:nvec)', vel(1,1:nvec)', ...
                vel(2,1:nvec)', a',b',az'];

        % plot predicted vectors
% This is for 3D
%        u_pre = zeros(3,nvec);
%        for i = 1:nvec
%                u_pre(:,i)  = dhat( 3*(i-1)+1 : 3*(i-1)+3 );
%        end
%        outmatrix2v = [llh_gps(2,1:nvec)', llh_gps(1,1:nvec)', zeros(1,nvec)', u_pre(3,:)', zeros(1,nvec)', zeros(1,nvec)', zeros(1,nvec)'];

%	outmatrix_temp = [llh_gps(2,1:nvec)', llh_gps(1,1:nvec)', u_pre(2,:)', u_pre(1,:)',u_pre(3,:)'];

% This is for 2D
        u_pre = zeros(2,nvec);
        for i = 1:nvec
                u_pre(:,i)  = dhat( 2*(i-1)+1 : 2*(i-1)+2 );
        end
        null = zeros(size(u_pre(1,:)))';
        outmatrix2 = [llh_gps(2,1:nvec)', llh_gps(1,1:nvec)',  u_pre(1,:)', ...
                  u_pre(2,:)', null, null, null];

% plot residual vectors
        res =   (vel(:,1:nvec)) - u_pre(:,:) ;

        outmatrix3 = [llh_gps(2,1:nvec)', llh_gps(1,1:nvec)',  res(1,:)',   res(2,:)', null,null,null];

        save obs.gmtvec outmatrix1 -ascii
        save mod.gmtvec outmatrix2 -ascii
%        save obs_vert.gmtvec outmatrix1v -ascii
%        save mod_vert.gmtvec outmatrix2v -ascii
        save res.gmtvec outmatrix3 -ascii
%        save NEUp_correction.gmtvec outmatrix_temp -ascii
end


%% Some code to difference 1974-1976 south flank displacements and 1974 SW rift displacements 
% 
% 
%%% TO SAVE FOR LATER PROCESSING
%
%
%% Plot Fault Outlines and Volume Sources in GMT plot

        if nf > 0
                for i=1:nf
                 displot_gmt( geom(i,:), dis_geom(i,:) )
                end
        end

        if nv >0
                 volplot_gmt( vgeom );
        end
% PRINT OUT MOMENT AND MOMENT MAGNITUDE
                clear Mo
                clear Mw
mmslip = slip/1000
for i=1:nf;

                Mo(i) = 1000 * dis_geom(i,1) * 1000 * dis_geom(i,2) * abs(sum(mmslip(i*3-2:i*3))) * 30E9;
                Mw(i) = 2/3*log10(Mo(i)) - 6.0;
%                disp(['   Fault Number ', num2str(i)]);
%                fprintf(1,'Moment %4.2e',  Mo(i) ); disp(' (Nm)'); disp('  ')
%                fprintf(1,'Mw %8.4f',  Mw(i) ); disp('  ')
        end
                Mo_total = sum(Mo);
                Mw_total = 2/3*log10(Mo_total) - 6.0;
                disp('   Total Geodetic Moment ');
                disp(' _______________________ ');
                fprintf(1,'Moment %4.2e',  Mo_total ); disp(' (Nm)'); disp('  ')
                fprintf(1,'Mw %8.4f',  Mw_total ); disp(' Geodetic Moment Magnitude ')

% END PRINT OUT MOMENT AND MOMENT MAGNITUDE
 
% Run Script
        if get(cb_plt, 'value') == 1
                !composite.map
        end


% IF Leveling data exists plot observed and predicted

if length(d_lev) > 0

        % plot observed level data
        figure
        errorbar (Len,d_lev, sigma_lev, sigma_lev, 'y+')
        hold on

        % plot modeled level data
        plot (Len,dhat(length(d_gps)+1:length(d_gps)+length(d_lev)), 'g')
        hold off;
end

% IF TILT DATA EXISTS -- PLOT TILT DATA IN GMT

%if length(d_tilt) > 0
%        clear outmatrix1
%        clear outmatrix2
%        clear nvec
%        clear a
%        clear b
%        clear az
%        nsta = length(d_tilt)/2
%%plot observed vectors
%        a(1) = sqrt(cov_tilt(1,1));
%        b(1) = sqrt(cov_tilt(2,2));
%        az(1) = 0;
%for i = 4:2:(nsta*2)
%        a(i/2) = sqrt(cov_tilt(i-1,i-1));
%        b(i/2) = sqrt(cov_tilt(i,i));
%        az(i/2) = 0;
%end
%        nvec = length(d_tilt_v);
%        outmatrix1 = [llh_tilt(2,1:nvec)', llh_tilt(1,1:nvec)', d_tilt_v(1,:)', ...
%                d_tilt_v(2,:)',a',b',az'];
%
%        % plot predicted vectors
%        u_pre = zeros(2,nvec);
%        i_tilt = length(d_gps)+length(d_lev) +1;
%        dhat_tilt = dhat(length(d_gps)+length(d_lev)+1:length(dhat));
%for i = 1: nvec
%                u_pre(:,i )  = dhat_tilt( 2*(i-1)+1 : 2*(i-1)+2 );
%end
%        null = zeros(size(u_pre(1,:)))';
%        outmatrix2 = [llh_tilt(2,1:nvec)', llh_tilt(1,1:nvec)', u_pre(1,:)', ...
%                 u_pre(2,:)', null, null, null];
% 
%        save tiltobs.gmtvec outmatrix1 -ascii
%        save tiltmod.gmtvec outmatrix2 -ascii
%end
%

disp('Done')

