        function [vel, cov, llh] = GetGPSdata(filename)
%
% Read GPS solution files
% Output:
%	vel 	- vector of 3D velocities
%	cov	- covariance matrix of 3D velocities
%	llh	- latitude longitude height
filename = filename(1,:);
	disp('Reading 3D GPS data'); disp(filename)
eval(['fopen ',filename]);
if ans == -1
	disp('Could not read file'); disp(filename)
else

% load data file: NOTE matrdvel returns last station as reference station 
	[vel,cov,NVEC,llh] = matrdvel(filename);
	nsta = NVEC+1;
	llh = llh(:,1:nsta);
	vel = vel(:,1:NVEC);
	cov3d = cov(1:3*(NVEC),1:3*(NVEC));
	clear cov;
	cov = cov3d;
% FOR 2D
%	vel = vel(1:2,1:NVEC);
%	cov3d = cov(1:3*(NVEC),1:3*(NVEC));
%	cov2d = cov3d2cov2d(cov3d);
%	clear cov;
%	cov = cov2d;
	disp(' Data File Read')
disp('GetGPSdata successfully read 3D GPS data');
	fclose(ans);
end
