% LoadData.m
% Script to load Different Data types

% read the various data files

%if get(cb_gpsdat, 'value') == 1
%        [vel,cov_gps,llh_gps] = GetGPSdata(get(getname_gps,'string'));
%        [vel,cov_gps,llh_gps] = Get_correct_GPSdata(get(getname_gps,'string'));
%        d_gps = vel(:);
%        Icov_gps = inv(cov_gps);
%        W_gps = chol(Icov_gps);
%        disp('GPS Postseismic Data Loaded - Corrected for secular motion!')
%else
%        d_gps = [];
%        Icov_gps = [];
%        W_gps = [];
%end
%

% FROM 2D GMT FILE:
if get(cb_gpsdat, 'value') == 1
[vel,cov_gps,llh_gps] = GetGMTdata(get(getname_gps,'string'));
d_gps = vel(:);
Icov_gps = inv(cov_gps);
W_gps = chol(Icov_gps);
disp('GPS Data Loaded from GMT file')
else
d_gps = [];
Icov_gps = [];
W_gps = [];
end
%
% FROM 3D GMT FILE:
%if get(cb_gpsdat, 'value') == 1
%  [vel,cov_gps,llh_gps] = GetGMT3Ddata(get(getname_gps,'string'));
%  d_gps = vel(:);
%  Icov_gps = inv(cov_gps);
%  W_gps = chol(Icov_gps);
%  disp('GPS Data Loaded from GMT file')
%else
%  d_gps = [];
%  Icov_gps = [];
%  W_gps = [];
%end
%%

if get(cb_levdat, 'value') == 1
        [d_lev, llh_lev, Len, sigma_lev, Icov_lev, W_lev] = ...
	GetLEVdata(get(getname_lev,'string'));
	disp('Leveling Data Loaded')
else
	d_lev = [];
	Icov_lev = [];
	W_lev = [];
end

if get(cb_tiltdat, 'value') == 1
clear d_tilt
clear cov_tilt
clear llh_tilt
        [d_tilt, cov_tilt, llh_tilt] = ...
	GetTILTdata(get(getname_tilt,'string'));
	disp('Tilt Data Loaded')
	d_tilt_v = d_tilt;
	d_tilt = d_tilt(:);
	Icov_tilt = inv(cov_tilt);
	W_tilt = chol(Icov_tilt);
else
	d_tilt = [];
	Icov_tilt = [];
	W_tilt = [];
%	disp('EDM Data Not Implemented')
end

%if get(cb_edmdat, 'value') == 1
%        [llh_edm1, llh_edm2, d_edm, sigma_edm, Icov_edm, W_edm] = ...
%        GetEDMdata(get(getname_edm,'string'));
%        disp('Trilateration Data Loaded')
%else
%        d_edm = [];
%        Icov_edm = [];
%        W_edm = [];
%end
%STILL NEED TO CONCATENATE THE DATA WITH THE REST
% concatenate data, covariance, and weight matrices
	d = [d_gps; d_lev; d_tilt(:)];

	W = [W_gps, zeros(length(d_gps),length(d_lev)), zeros(length(d_gps),length(d_tilt)); ...
	     zeros(length(d_lev),length(d_gps)),W_lev, zeros(length(d_lev),length(d_tilt)); ...
	     zeros(length(d_tilt),length(d_gps)),zeros(length(d_tilt),length(d_lev)),W_tilt];

	Icov = [Icov_gps, zeros(length(d_gps),length(d_lev)), zeros(length(d_gps),length(d_tilt)); ...
	     zeros(length(d_lev),length(d_gps)),Icov_lev, zeros(length(d_lev),length(d_tilt)); ...
	     zeros(length(d_tilt),length(d_gps)),zeros(length(d_tilt),length(d_lev)),Icov_tilt];

