% Duzce and Izmit Earthquake values;
% surface rupture length , average displacement, maximum displacement

duzsrl=43;
duzave=3.75;
duzmax=4.90;
izmsrl=120;
izmave=2.80;
izmmax=5.00;

% Earthquakes occured within the North Anatolian Fault Zone since 1939.
% Average displacement & maximum displacement versus surface rupture length
% Wells, R.L., Coppersmith, K.J.( 1994). Table 1. Only reliable earthquakes
% are investigated.

ave1 = [6.6000000e-001   
   1.8000000e+000    
   9.0000000e-001 
  2.1000000e+000  
  5.5000000e-001  
  1.5000000e-001  
  1.6300000e+000  
  5.0000000e-001  
  2.0500000e+000   ];
ave2 = [  4.7000000e+001
    1.8000000e+002
    3.8000000e+001
    5.8000000e+001
    4.0000000e+001
    3.0000000e+001
    8.0000000e+001
    2.6000000e+001
    5.5000000e+001 ];

maxi1 = [1.0000000e+000
  7.5000000e+000
  2.0000000e+000
  3.6000000e+000
  3.0000000e-001
  1.6000000e+000
  4.3500000e+000
  1.6500000e+000 
  4.0000000e-001 
  2.6000000e+000 
  6.0000000e-001 
  6.3000000e-001 
  3.5000000e+000 
  1.2000000e+000 
  2.0000000e-001  ];

maxi2 = [ 1.4000000e+001
   3.6000000e+002
   4.7000000e+001
   1.8000000e+002
   9.0000000e+000
   3.8000000e+001
   5.8000000e+001
   4.0000000e+001
   3.0000000e+001
   8.0000000e+001
   3.8000000e+001
   2.6000000e+001
   5.5000000e+001
   1.2000000e+001
   3.0000000e+001 ];

% 

srl =1:10:1000;

% maximum displacement
% Wells, R.L., Coppersmith, K.J.( 1994). Table 2C.
a= -1.38;
b = 1.02;
ma = 0.15;
mb = 0.09;
md = 10.^( a + b.*log10(srl));
% confidence interval computation
sig = sqrt( ma*ma.*md.*md + mb*mb.*md.*md.*log10(srl).*log10(srl));
% probability is% 95 
mdup = md + 1.96 * sig;
mdlow = md - 1.96 * sig;

% average displacements
% Wells, R.L., Coppersmith, K.J.( 1994). Table 2C.

a1= -1.43;
b1 = 0.88;
ma1 = 0.18;
mb1 = 0.11;
ad = 10.^( a1 + b1.*log10(srl));
% confidence interval computation
sig1 = sqrt( ma1*ma1.*ad.*ad + mb1*mb1.*ad.*ad.*log10(srl).*log10(srl));
% probability is% 95 
adup = ad + 1.96 * sig1;
adlow = ad - 1.96 * sig1;


%subplot(2,1,1)
figure
loglog(srl,ad,'-k','LineWidth',2)
hold on
loglog(srl,adup,'-k','LineWidth',2,'Color',[0.8,0.8,0.8])
loglog(srl,adlow,'-k','LineWidth',2,'Color',[0.8,0.8,0.8])
loglog(ave2,ave1,' ko','MarkerEdgeColor','k','MarkerFaceColor','w','MarkerSize',12)
loglog(duzsrl,duzave,' kh','MarkerEdgeColor','k','MarkerFaceColor','w','MarkerSize',16)
loglog(izmsrl,izmave,' kd','MarkerEdgeColor','k','MarkerFaceColor','w','MarkerSize',16)


hold off

%subplot(2,1,2)
figure
loglog(srl,md,'-k','LineWidth',2)
hold on
loglog(srl,mdup,'-k','LineWidth',2,'Color',[0.8,0.8,0.8])
loglog(srl,mdlow,'-k','LineWidth',2,'Color',[0.8,0.8,0.8])
loglog(maxi2,maxi1,' ko','MarkerEdgeColor','k','MarkerFaceColor','w','MarkerSize',12)
loglog(duzsrl,duzmax,' kh','MarkerEdgeColor','k','MarkerFaceColor','w','MarkerSize',16)
loglog(izmsrl,izmmax,' kd','MarkerEdgeColor','k','MarkerFaceColor','w','MarkerSize',16)
hold off

