%   distrib.m
%
%   Fault geometry parameters computation for segmentation of one fault rupture surface
%
%

ro = 180. / pi;
ss= 3.6207;
ds = 0.6312;
op = 0.000;
dip = 54.61;
w = 27.1623;
fo1= 40.7585;
fo2 = 40.7720;
lo1 = 30.9787;
lo2 = 31.5249;
nf = 9;
nl = 16;
dw = w /nf;
dl = (lo2 - lo1 ) / nl;
dd = sin (dip / ro) * w / nf;
df = cos(dip/ro) * w/6371. *ro / nf;
dip = -dip;


fid = fopen('Fault','w+')

for iif = 1:nf;
   for iil = 1:nl;
      
      f1(iif,iil) = fo1 + (iif-1)*df;
      f2(iif,iil) = fo1 + (iif - 1)* df;
      l1(iif,iil) = lo1 + (iil - 1)*dl;
      l2(iif,iil) = lo1 + iil * dl;
      d(iif,iil)= -(iif-1)* dd;
      
      fprintf(fid,' %8.4f %8.4f %8.4f %8.4f %8.4f %8.4f %8.4f %8.4f %8.4f %8.4f\n',...
         dw, d(iif,iil), dip, f1(iif,iil), l1(iif,iil), f2(iif,iil), l2(iif,iil), ss,ds,op );
      
   end
   
end

fclose(fid)